const glob = require('glob')
const path = require('path')
const dbPath = process.env.DB_DATA_PATH || '/tmp/hmi_data.sqlite'

module.exports = {
    initializeDataDB: async (logger, sqlite3) => {
        let db_sqlite = await sqlite3.open(dbPath, sqlite3.OPEN_READWRITE | sqlite3.OPEN_CREATE)
        .catch(err => {
            logger.error(err.message);
        });
        logger.info('Connected to the hmi_data database.');

        //Initialize database stuff
        await db_sqlite.run('CREATE TABLE IF NOT EXISTS measures (id INTEGER PRIMARY KEY AUTOINCREMENT, data_value TEXT)')
        await db_sqlite.run('DELETE FROM measures')
        await db_sqlite.run('INSERT INTO measures(data_value) VALUES ("")')

        await db_sqlite.run('CREATE TABLE IF NOT EXISTS deviceInfo (id INTEGER PRIMARY KEY AUTOINCREMENT, param_name TEXT, param_value TEXT)')
        await db_sqlite.run('DELETE FROM deviceInfo')

        //Add models
        db_sqlite.measures = require('./models/measures')(db_sqlite, logger)
        db_sqlite.device = require('./models/device')(db_sqlite, logger)

        return db_sqlite;
    }
}

