module.exports = function (db, logger){
    async function getSnapShotMeasures() {
        let query = "SELECT * FROM `measures` ORDER BY id ASC LIMIT 1";
        let rslt = await db.get(query)
        if(rslt.data_value)
            return JSON.parse(rslt.data_value)
        else {
            logger.warn("No snapshot measures data available")
            return null
        }
    }
    function getSnapShotMeasuresDemo() {
        let json_data = { 
            "Timestamp": 3.35,
            "CurrentSum": Math.random() * (10000) + 1,
            "VoltageSum": Math.random() * (10000) + 1,
            "VoltageFundSum": Math.random() * (10000) + 1,
            "CurrentFundSum": Math.random() * (10000) + 1,
            "Frequency": Math.random() * (10000) + 1,
            "Power_P": Math.random() * (10000) + 1,
            "Power_S": Math.random() * (10000) + 1,
            "PowerFactor": Math.random()
        };
        let response = [];
        response.push(json_data);
        return response;
    }
    function updateSnapshotMeasures(data){
        let query = "UPDATE `measures` SET data_value = '" + JSON.stringify(data) + "'"
        //logger.info(query)
        db.run(query)
    }
    function getAllMeasuresEDrive(req, res) {
        let query = "SELECT * FROM `MeasuresEdrive` ORDER BY id ASC";

        if (!db)
            return;
        // execute query
        db.query(query, (err, result) => {
            if (err) {
                res.redirect('/');
            }
            res.send(result);
        });
    }
    function getAllMeasures(req, res) {
        let query = "SELECT * FROM `Measures` ORDER BY id ASC";

        if (!db)
            return;
        // execute query
        db.query(query, (err, result) => {
            if (err) {
                res.redirect('/');
            }
            res.send(result);
        });
    }
    function getMeasuresList(req, res) {
        //return component list with connector and channels
    }
    function getComponents(req, res) {
        let query = "SELECT DISTINCT Component FROM `Measures` ORDER BY id ASC";

        if (!db)
            return;
        // execute query
        db.query(query, (err, result) => {
            if (err) {
                res.redirect('/');
            }
            res.send(result);
        });
    }
    function getConnectors(req, res) {
        let sql_where = "";
        let component = req.query.component;
        if (component) {
            sql_where = " WHERE Component='" + component + "'";
        }
        let query = "SELECT DISTINCT Connector FROM `Measures`" + sql_where + " ORDER BY id ASC";

        if (!db)
            return;
        // execute query
        db.query(query, (err, result) => {
            if (err) {
                res.send(err);
            }
            res.send(result);
        });
    }
    function getComponentData(req, res) {
        let sql_where = "";
        let component = req.query.component;
        let connector = req.query.connector;
        if (component) {
            sql_where = " WHERE Component='" + component + "'";
            if (connector) {
                sql_where += " AND Connector='" + connector + "'";
            }
        }
        let query = "SELECT * FROM `Measures`" + sql_where + " ORDER BY id ASC";

        if (!db)
            return;
        // execute query
        db.query(query, (err, result) => {
            if (err) {
                res.redirect('/');
            }
            res.send(result);
        });
    }

    return {
        getSnapShotMeasures: getSnapShotMeasures,
        getSnapShotMeasuresDemo: getSnapShotMeasuresDemo,
        updateSnapshotMeasures: updateSnapshotMeasures
    }
}