

function decimalToHex(d, padding) {
    var buf = new Buffer(4);
    var hex = Number(d).toString(16);
    padding = typeof (padding) === "undefined" || padding === null ? padding = 2 : padding;

    while (hex.length < padding) {
        hex = "0" + hex;
    }

    return hex;
}


function swap(b, n, m) {
    const i = b[n];
    b[n] = b[m];
    b[m] = i;
}


function swap32(buf) {
    // For Buffer.length < 192, it's generally faster to
    // do the swap in javascript. For larger buffers,
    // dropping down to the native code is faster.
    const len = buf.length;
    if (len % 4 !== 0)
        throw new ERR_INVALID_BUFFER_SIZE('32-bits');
    if (len < 192) {
        for (var i = 0; i < len; i += 4) {
            swap(buf, i, i + 3);
            swap(buf, i + 1, i + 2);
        }
        return buf;
    }
    //return _swap32(this);
}

function findFormulaIndexByName(name, arr){
    if(name == null || arr == null)
        return -1;

    let pos = -1;
    for( let i = 0; i < arr.length; i ++){
        if(arr[i].DataName == name) {
            pos = i;
            break;
        }
    }
    return pos;
}

module.exports.Swap32 = swap32;
module.exports.decimalToHex = decimalToHex;
module.exports.findFormulaIndexByName = findFormulaIndexByName;
