const { Router } = require('express')

module.exports = Router({mergeParams: true})
.get('/settings.html', async (req, res, next) => {
    try {
        let viewsOpt = {};
        viewsOpt.url = "settings";
        viewsOpt.demo = await req.dbs.settings.getDemoMode()
        viewsOpt.theme = await req.dbs.settings.getTheme()
        viewsOpt.polling_time = await req.dbs.settings.getPollingTime()
        viewsOpt.menu_behaviour = await req.dbs.settings.getMenuBehaviour()
        res.render(viewsOpt.url, { data: viewsOpt });

    } catch(error) {
        next(error)
    }

})
.post('/settings.html', function (req, res) {  
    try {
        if (req.body.demo != null) {
            req.dbs.settings.setDemoMode(req.body.demo)
        }
        if (req.body.theme != null) {
            req.dbs.settings.setTheme(req.body.theme)
        }
        if (req.body.polling_time != null) {
            switch(req.body.polling_time){
                case '1':
                    req.dbs.settings.setPollingTime(500)
                    break
                case '2':
                    req.dbs.settings.setPollingTime(1000)
                    break
                case '3':
                    req.dbs.settings.setPollingTime(1500)
                    break
                case '4':
                    req.dbs.settings.setPollingTime(2000)
                    break
            }            
        }
        if (req.body.menu_behaviour != null){
            req.dbs.settings.setMenuBehaviour(req.body.menu_behaviour)
        }
        res.send({ result: true });

    } catch(error) {
        next(error)
    }
});
