const { Router } = require('express')
const filePath = '/tmp/hbm-genseries-hmi.bin'

async function moveFile(sampleFile){
    return new Promise(resolve => {
        sampleFile.mv(filePath, function(err) {
            if (err)
                resolve(false)
            resolve(true)
        });
    });
}

module.exports = Router({mergeParams: true})
.get('/*', async (req, res, next) => {

    try {
        let viewsOpt = {};
        viewsOpt.url = "upgrade"
        viewsOpt.hmiVersion = req.hmiVersion
        res.render(viewsOpt.url, { data: viewsOpt })

    } catch(error) {
        next(error)
    }

})
.post('/upgrade', async (req, res, next) => {
    
    try {
        if (!req.files || Object.keys(req.files).length === 0) {
            return res.status(400).send('No files were uploaded.')
        }

        // The name of the input field (i.e. "file") is used to retrieve the uploaded file
        let sampleFile = req.files.file;
        
        let rslt = await moveFile(sampleFile)

        if(rslt == false)
            return res.status(400).send('Error moving file.')

        rslt = await req.dev.upgradeHMIdevice(filePath)

        if(rslt){
            res.send('{"result": true}')
        } else {
            res.send('{"result": false}')
        }

    } catch(error) {
        next(error)
    }

})
