const glob = require('glob')
const Router = require('express').Router

const requireFunc = typeof __webpack_require__ === "function" ? __non_webpack_require__ : require;

module.exports = () => glob
.sync('**/*.js', {
    cwd: `${__dirname}/`,
    ignore: '**/*.test.js',
})
.map(filename => requireFunc(`./${filename}`))
.filter(router => Object.getPrototypeOf(router) == Router)
.reduce((rootRouter, router) => rootRouter.use(router), Router({ mergeParams: true }))
