var WebSocketServer = require('websocket').server;
var http = require('http');
var websocket_connected = false;
var logger = null
var clientsNumber = 0
var connection = null

function initWebSocket(log) {
    logger = log
    var server = http.createServer(function (request, response) {
        logger.info('Received request for ' + request.url);
        response.writeHead(404);
        response.end();
    });
    server.listen(8080, function () {
        logger.info('WebSocket Server is listening on port 8080');
    });
    ////websocket server
    wsServer = new WebSocketServer({
        httpServer: server,
        // You should not use autoAcceptConnections for production
        // applications, as it defeats all standard cross-origin protection
        // facilities built into the protocol and the browser.  You should
        // *always* verify the connection's origin and decide whether or not
        // to accept it.
        autoAcceptConnections: false
    });
    wsServer.on('request', function (request) {
        if (!originIsAllowed(request.origin)) {
            // Make sure we only accept requests from an allowed origin
            request.reject();
            console.log('Connection from origin ' + request.origin + ' rejected.');
            return;
        }

        connection = request.accept('websocket', request.origin);
        if (connection) {
            clientsNumber++;
            logger.info('WebSocket - Connection accepted, clients: ' + clientsNumber);
            connection.on('message', function (message) {
                logger.info("WebSocket - received message from client");
            });
            connection.on('close', function (reasonCode, description) {
                //give a timeout to disconnect user
                setTimeout(updateUserCnt, 2000);
            });
        }
    });
}

function originIsAllowed(origin) {
    logger.info(origin)
    return true;
}

function areClientsConnected() {
    return clientsNumber > 0 ? true : false
}

function sendWebSocketMsg(msg) {
    if (connection) {
        connection.sendUTF(msg);
    }
}

function updateUserCnt() {
    if (clientsNumber > 0)
        clientsNumber--;
    logger.info('WebSocket - Peer ' + connection.remoteAddress + ' disconnected, clients: ' + clientsNumber);
}

module.exports.initWebSocket = initWebSocket
module.exports.areClientsConnected = areClientsConnected
module.exports.sendWebSocketMsg = sendWebSocketMsg