/*=========================================================================================
    File Name: line.js
    Description: Flot line chart
    ----------------------------------------------------------------------------------------
    Item Name: Modern Admin - Clean Bootstrap 4 Dashboard HTML Template
   Version: 3.0
    Author: PIXINVENT
    Author URL: http://www.themeforest.net/user/pixinvent
==========================================================================================*/

// Line chart
// ------------------------------
$(window).on("load", function(){

    var data1 = [];

    function getData() {
        $.ajax({
            dataType: "json",
            url: '/api/measures/list/edrive/all',
            success: update
          });
    }

    var options = {
        legend: {
            show: true
        },
        grid: {
            borderWidth: 0,
            borderColor: {
                top:"transparent",
                right:"transparent",
                bottom:"#fdd5d5",
                left:"transparent",
            },
            color: '#999',
            hoverable: true,
            minBorderMargin: 20,
            labelMargin: 10,
            margin: {
                top: 8,
                bottom: 20,
                left: 20
            },
        },
        series: {
            lines: {
                show: true,
                lineWidth: 0,
                fill: true,
                fillColor: { colors: [ { opacity: 0.1 }, { opacity: 1.0 } ] }
            },
            points: {
                show: false
            },
        },
        yaxis: {
            tickSize: 1
        },
        xaxis: {
            show: true
        },
        colors: ['#c70800']
    };

    function update(data){        

        var min_max = [];
        data.forEach(element => {
            var temp = [ element.Timestamp, formatNumber(element.Power_P).value ];
            data1.push(temp);
            min_max.push(formatNumber(element.Power_P).value);
        });

        var minMaxRslt = findMinMax(min_max);
        options.yaxis.min = minMaxRslt[0] - 1;
        options.yaxis.max = minMaxRslt[1] + 1;

        console.log(minMaxRslt);

        var dataset = [
            { label: "Power (kW)", data: data1}
        ];

        $.plot("#power-placeholder", dataset, options);
    }

    //Graph tooltip stuff
    $("<div id='tooltip'></div>").css({
        position: "absolute",
        display: "none",
        border: "1px solid #fdd",
        padding: "2px",
        "background-color": "#fee",
        opacity: 0.80
    }).appendTo("body");

    $("#power-placeholder").bind("plothover", function (event, pos, item) {

        if (!pos.x || !pos.y) {
            return;
        }
        
        if (item) {
            var x = item.datapoint[0].toFixed(2),
                y = item.datapoint[1].toFixed(2) + " kW";

            $("#tooltip").html(y)
                .css({top: item.pageY+5, left: item.pageX+5})
                .fadeIn(200);
        } else {
            $("#tooltip").hide();
        }
        
    });

    $("#power-placeholder").bind("plothovercleanup", function (event, pos, item) {
            $("#tooltip").hide();
    });

    getData();
});