
// ------------------------------
$(window).on("load", function(){

    var data1 = [];
    var data2 = [];

    /*for (var i = 0; i < d.length; ++i) {
        d[i][0] += 60 * 60 * 1000;
    }*/

    function getData() {
        $.ajax({
            dataType: "json",
            url: '/api/measures/list/edrive/all',
            success: update
          });
    }

    var options = {
        xaxis: {
            show: true
        },
        selection: {
            mode: "x"
        },
        grid: {
            hoverable: true, 
            clickable: true,
            borderWidth: 0,
            borderColor: "#e9e9e9",
            backgroundColor: { colors: ["#000", "#666"] },
            color: '#999',
            minBorderMargin: 20,
            labelMargin: 10,
            margin: {
                top: 8,
                bottom: 20,
                left: 20
            }
        },
        yaxis: {
            min: 0
        },
        legend: {
            show: true,
            position: "ne",// or "nw" or "se" or "sw"
            labelFormatter: function(label, series) {
                // series is the series object for the label
                return '<a>&Sigma; ' + label + '</a>';
            }
            
        },
        series: {
            lines: {
                show: true,
                lineWidth: 2,
                fill: true,
                fillColor: { colors: [ { opacity: 0.4 }, { opacity: 0.1 } ] }
            },
            shadowSize: 0
        }
    };

    function update(data){        

        var min_max1 = [];
        var min_max2 = [];
        data.forEach(element => {
            var temp = [ element.Timestamp, element.VoltageFundSum];
            data1.push(temp);
            temp = [ element.Timestamp, formatNumber(element.VoltageSum).value];
            data2.push(temp);
            min_max1.push(formatNumber(element.VoltageFundSum).value);
            min_max2.push(formatNumber(element.VoltageSum).value);
        });
        var minMax1 = findMinMax(min_max1);
        var minMax2 = findMinMax(min_max2);
        options.yaxis.min = minMax1[0] <= minMax2[0] ? minMax1[0] : minMax2[0];
        options.yaxis.max = minMax1[1] >= minMax2[1] ? minMax1[1] : minMax2[1];

        var dataset = [
            { label: "Voltage Fundamental", data: data1},
            { label: "Voltage", data: data2 }
        ];

        var plot = $.plot("#voltageFundSumAll-placeholder", dataset, options);

        var overview = $.plot("#voltageFundSumAll-overview", dataset, {
            series: {
                lines: {
                    show: true,
                    lineWidth: 1
                },
                shadowSize: 0
            },
            legend: {
                show: false
            },
            xaxis: {
                ticks: []
                
            },
            yaxis: {
                ticks: [],
                autoscaleMargin: 0.1
            },
            selection: {
                mode: "x"
            },
            grid: {
                borderWidth: 0,
                borderColor: "#e9e9e9",
                backgroundColor: { colors: ["#000", "#666"] },
                minBorderMargin: 20,
                labelMargin: 10,
                margin: {
                    top: 8,
                    bottom: 20,
                    left: 40
                },
            }
        });

        // now connect the two

        $("#voltageFundSumAll-placeholder").bind("plotselected", function (event, ranges) {

            // do the zooming
            $.each(plot.getXAxes(), function(_, axis) {
                var opts = axis.options;
                opts.min = ranges.xaxis.from;
                opts.max = ranges.xaxis.to;
            });
            plot.setupGrid();
            plot.draw();
            plot.clearSelection();

            // don't fire event on the overview to prevent eternal loop

            overview.setSelection(ranges, true);
        });

        $("#voltageFundSumAll-overview").bind("plotselected", function (event, ranges) {
            plot.setSelection(ranges);
        });
       
    }

     //Graph tooltip stuff
     $("<div id='tooltip'></div>").css({
        position: "absolute",
        display: "none",
        border: "1px solid #fdd",
        padding: "2px",
        "background-color": "#fee",
        opacity: 0.80
    }).appendTo("body");

    $("#voltageFundSumAll-placeholder").bind("plothover", function (event, pos, item) {

        if (!pos.x || !pos.y) {
            return;
        }
        
        if (item) {
            var x = item.datapoint[0].toFixed(2),
                y = item.datapoint[1].toFixed(2) + " V";

            $("#tooltip").html(y)
                .css({top: item.pageY+5, left: item.pageX+5})
                .fadeIn(200);
        } else {
            $("#tooltip").hide();
        }
        
    });

    $("#voltageFundSumAll-placeholder").bind("plothovercleanup", function (event, pos, item) {
            $("#tooltip").hide();
    });

    getData();
});