var ranges = [
    { divider: 1e18, suffix: 'E' },
    { divider: 1e15, suffix: 'P' },
    { divider: 1e12, suffix: 'T' },
    { divider: 1e9, suffix: 'G' },
    { divider: 1e6, suffix: 'M' },
    { divider: 1e3, suffix: 'k' }
];

function formatNumber(n) {
    if(n == null || n.length <= 0)
	    return "-";
    const sizeNumber = 4;
    var number = n;
    var decimalStr = "";
    var strSuffix = "";

    for (var i = 0; i < ranges.length; i++) {
        if (n >= ranges[i].divider) {
            number = n / ranges[i].divider;
            strSuffix = ranges[i].suffix;
            break;
        }
    }

    //console.log(number);
    var precisionValue = number.toFixed(3);//set decimal to 3 digits
    var numberStr = precisionValue.toString().split('.');

    var nlength = numDigits(numberStr[0]);
    if(nlength < sizeNumber){
	//we need decimal part
	if (numberStr[1]) {
	    decimalStr += '.';
	    decimalStr += numberStr[1].substring(0, sizeNumber - nlength);;
        } 
    }
    return { value: numberStr[0], valueDecimal: decimalStr, suffix: strSuffix };
}

function findMinMax(arr) {

    let min = arr[0], max = arr[0];

    for (let i = 1, len = arr.length; i < len; i++) {
        let v = arr[i];
        min = (v < min) ? v : min;
        max = (v > max) ? v : max;
    }

    return [min, max];
}

function numDigits(x) {
  return Math.max(Math.floor(Math.log10(Math.abs(x))), 0) + 1;
}
